t / test-lib.shon commit [PATCH] Doc: update git-send-email-script documentation. (a6d62cd)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5
   6# For repeatability, reset the environment to known value.
   7LANG=C
   8TZ=UTC
   9export LANG TZ
  10unset AUTHOR_DATE
  11unset AUTHOR_EMAIL
  12unset AUTHOR_NAME
  13unset COMMIT_AUTHOR_EMAIL
  14unset COMMIT_AUTHOR_NAME
  15unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  16unset GIT_AUTHOR_DATE
  17unset GIT_AUTHOR_EMAIL
  18unset GIT_AUTHOR_NAME
  19unset GIT_COMMITTER_EMAIL
  20unset GIT_COMMITTER_NAME
  21unset GIT_DIFF_OPTS
  22unset GIT_DIR
  23unset GIT_EXTERNAL_DIFF
  24unset GIT_INDEX_FILE
  25unset GIT_OBJECT_DIRECTORY
  26unset SHA1_FILE_DIRECTORIES
  27unset SHA1_FILE_DIRECTORY
  28
  29# Each test should start with something like this, after copyright notices:
  30#
  31# test_description='Description of this test...
  32# This test checks if command xyzzy does the right thing...
  33# '
  34# . ./test-lib.sh
  35
  36error () {
  37        echo "* error: $*"
  38        exit 1
  39}
  40
  41say () {
  42        echo "* $*"
  43}
  44
  45test "${test_description}" != "" ||
  46error "Test script did not set test_description."
  47
  48while test "$#" -ne 0
  49do
  50        case "$1" in
  51        -d|--d|--de|--deb|--debu|--debug)
  52                debug=t; shift ;;
  53        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
  54                immediate=t; shift ;;
  55        -h|--h|--he|--hel|--help)
  56                echo "$test_description"
  57                exit 0 ;;
  58        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
  59                verbose=t; shift ;;
  60        *)
  61                break ;;
  62        esac
  63done
  64
  65if test "$verbose" = "t"
  66then
  67        exec 4>&2 3>&1
  68else
  69        exec 4>/dev/null 3>/dev/null
  70fi
  71
  72test_failure=0
  73test_count=0
  74
  75
  76# You are not expected to call test_ok_ and test_failure_ directly, use
  77# the text_expect_* functions instead.
  78
  79test_ok_ () {
  80        test_count=$(expr "$test_count" + 1)
  81        say "  ok $test_count: $@"
  82}
  83
  84test_failure_ () {
  85        test_count=$(expr "$test_count" + 1)
  86        test_failure=$(expr "$test_failure" + 1);
  87        say "FAIL $test_count: $1"
  88        shift
  89        echo "$@" | sed -e 's/^/        /'
  90        test "$immediate" == "" || exit 1
  91}
  92
  93
  94test_debug () {
  95        test "$debug" == "" || eval "$1"
  96}
  97
  98test_expect_failure () {
  99        test "$#" == 2 ||
 100        error "bug in the test script: not 2 parameters to test-expect-failure"
 101        say >&3 "expecting failure: $2"
 102        if eval >&3 2>&4 "$2"
 103        then
 104                test_failure_ "$@"
 105        else
 106                test_ok_ "$1"
 107        fi
 108}
 109
 110test_expect_success () {
 111        test "$#" == 2 ||
 112        error "bug in the test script: not 2 parameters to test-expect-success"
 113        say >&3 "expecting success: $2"
 114        if eval >&3 2>&4 "$2"
 115        then
 116                test_ok_ "$1"
 117        else
 118                test_failure_ "$@"
 119        fi
 120}
 121
 122test_done () {
 123        case "$test_failure" in
 124        0)      
 125                # We could:
 126                # cd .. && rm -fr trash
 127                # but that means we forbid any tests that use their own
 128                # subdirectory from calling test_done without coming back
 129                # to where they started from.
 130                # The Makefile provided will clean this test area so
 131                # we will leave things as they are.
 132
 133                say "passed all $test_count test(s)"
 134                exit 0 ;;
 135
 136        *)
 137                say "failed $test_failure among $test_count test(s)"
 138                exit 1 ;;
 139
 140        esac
 141}
 142
 143# Test the binaries we have just built.  The tests are kept in
 144# t/ subdirectory and are run in trash subdirectory.
 145PATH=$(pwd)/..:$PATH
 146
 147# Test repository
 148test=trash
 149rm -fr "$test"
 150mkdir "$test"
 151cd "$test"
 152git-init-db 2>/dev/null || error "cannot run git-init-db"